class cosa {

  PVector pos, vel, acc;
  float sz;
  float velAcercamiento, maxVel;

  cosa(float _x, float _y, float _minAcerc, float _maxAcerc, float _minMax, float _maxMax, int _minSz, int _maxSz) {
    pos = new PVector(_x,_y);
    vel = new PVector(0,0);
    acc = new PVector(0,0);
    velAcercamiento = random(_minAcerc,_maxAcerc);
    maxVel = random(_minMax,_maxMax);
    sz = int(random(_minSz,_maxSz));
  }

  void run() {
    update();
    drawMe();
  }

  void update() {  
    //actualizamos velocidad
    vel.add(acc);
    vel.limit(maxVel);
    pos.add(vel);
    acc.mult(0);
  }

  void drawMe() {

    //y finalmente, dibujamos
    PVector dis = new PVector (mouseX-pos.x,mouseY-pos.y); 
    //atan2 para saber la orientaciÃ³n relativa del triÃ¡ngulo dibujado
    //respecto al mouse (en radianes esto es, de 0 a 2*PI)
    float ang = atan2(dis.y,dis.x);
    //println(ang);
    pushMatrix();
    //movemos el punto de referencia para el dibujo
    translate(pos.x,pos.y);
    //rotamos
    rotate(ang);
    //dibujamos
    fill(0);
    triangle(0,0,-sz,sz/4,-sz,-sz/4);
    popMatrix();
  }

  void addForce(PVector _f) {
    //acc.add(_f);
    //añadimos la fuerza a la acceleración, según el factor tamaño
    acc.add(PVector.mult(_f,sz));
  }

  void calcularAcercamiento() {
    //calculamos la distáncia entre el mouse y la bola en los 2 ejes
    PVector mouse = new PVector(mouseX,mouseY);
    PVector dir = PVector.sub(mouse,pos);
    //normalizamos este vector de direccion. Esto es, le damos magnitud 1:
    dir.normalize();
    //y lo multiplicamos por la velocidad:
    dir.mult(velAcercamiento);
    addForce(dir);
  }
}

